<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Templates"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.0 / November 2012 ==

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

$directory = basename(dirname($_SERVER['PHP_SELF'])); 

require(CPO_BASEDIR.'_include/check.php');
require(CPO_BASEDIR.'_include/header.php');

$dir = CPO_BASEDIR.$activeModules['templates']['directory'];

if (!is_writeable($dir.'/files')) { 
	$message[] = $nok.sprintf(__('The directory <em>%s</em> is not writeable.'),$dir.'/files');
	$message[] = $sol.sprintf(__('Please make sure that the user your webserver is running as has write access to the <em>%s</em> directory. Usually you can use your FTP client or command line tools to do so.'),$moduleDirectory);
}

printPageHeader(
    __('Templates'),
    __('In this view you can export and import page and article templates.')
);


// character_set_connection lesen
	$dbm = new DB;
	$dbm->query("SHOW VARIABLES LIKE 'character_set_connection';");
	$dbm->next_record();
	$charSet = $dbm->v('Value');

if ($_REQUEST['action'] == 'export_template' )  {
    $dbm = new DB;
    $dbm->query('SELECT name FROM '.CPO_TEMPLATES.' WHERE id='.addslashes($_REQUEST['template']));
    $dbm->next_record();
    $templateName = $dbm->v('name');

	$filename = "Template.".$templateName.".".$charSet.".sql.txt";
	$file = fopen($dir."/files/".$filename, "wb");

    fputs ($file, 'SET CHARACTER SET '.$charSet.';'."\n");
    $fields = array();
    $fieldnames = array();
    $fieldsequalsvalues = array();
    $dbm = new DB;
    $dbm->query('SHOW COLUMNS FROM '.CPO_TEMPLATES);
    while($dbm->next_record()) {
        if ($dbm->v('Field') == 'id')  continue;
        $fieldnames[] = $dbm->v('Field');
        $fields[] = "`".$dbm->v('Field')."`";
        $fieldstring = implode(", ", $fields);
    }
    $dbm = new DB;
    $dbm->query('SELECT '.$fieldstring.' FROM '.CPO_TEMPLATES.' WHERE id='.addslashes($_REQUEST['template']));
    while($dbm->next_record()) {
        $fieldsequalsvalues = array();
        foreach ($fieldnames AS $field)  {
            $value = str_replace("'","''",$dbm->v($field));
            if ($field == 'name') $value .= ' [IMPORT]';
            if ($field == 'c_time')  $value = '###CPO_TEMPLATES_CTIME###';
            if ($field == 'changer') $value = '###CPO_TEMPLATES_CHANGER###';
            $value = addcslashes($value,'\\');
            $value = str_replace("\r",'\r',$value);
            $value = str_replace("\n",'\n',$value);
            $fieldsequalsvalues[] = ($charSet == 'utf8') ? "'".utf8_encode($value)."'" : "'".$value."'";
        }
        $fieldsequalsvaluesstring = implode(", ", $fieldsequalsvalues);
        $insertstring = "INSERT INTO ###CPO_TEMPLATES### (".$fieldstring.") VALUES (".$fieldsequalsvaluesstring."); "."\n";
        fputs ($file, $insertstring);
    }
    // Placeholders
    $fields = array();
    $fieldnames = array();
    $fieldsequalsvalues = array();
    $dbm = new DB;
    $dbm->query('SHOW COLUMNS FROM '.CPO_PLACEHOLDERS);
    while($dbm->next_record()) {
        if ($dbm->v('Field') == 'id')  continue;
        $fieldnames[] = $dbm->v('Field');
        $fields[] = "`".$dbm->v('Field')."`";
        $fieldstring = implode(", ", $fields);
    }
    $dbm = new DB;
    $dbm->query('SELECT '.$fieldstring.' FROM '.CPO_PLACEHOLDERS.' WHERE templates_id='.addslashes($_REQUEST['template']));
    while($dbm->next_record()) {
        $fieldsequalsvalues = array();
        foreach ($fieldnames AS $field)  {
            if ($field == 'templates_id') {
                $fieldsequalsvalues[] = '###CPO_TEMPLATES_ID###';
                continue;
            }
            $value = str_replace("'","''",$dbm->v($field));
            $value = addcslashes($value,'\\');
            $value = str_replace("\r",'\r',$value);
            $value = str_replace("\n",'\n',$value);
            $fieldsequalsvalues[] = ($charSet == 'utf8') ? "'".utf8_encode($value)."'" : "'".$value."'";
        }
        $fieldsequalsvaluesstring = implode(", ", $fieldsequalsvalues);
        $insertstring = "INSERT INTO ###CPO_PLACEHOLDERS### (".$fieldstring.") VALUES (".$fieldsequalsvaluesstring."); "."\n";
        fputs ($file, $insertstring);
    }
    fclose ($file);
	$message[] = sprintf(__('Template was saved as <em>%s</em>.'), '<a href="files/'.$filename.'" target="_blank">'.$activeModules['templates']['directory']."/files/".$filename.'</a>');
}
if ($_REQUEST['action'] == 'export_page_template' )  {
    $dbm = new DB;
    $dbm->query('SELECT name FROM '.CPO_PAGETEMPLATES.' WHERE id='.addslashes($_REQUEST['pagetemplate']));
    $dbm->next_record();
    $templateName = $dbm->v('name');

	$filename = "PageTemplate.".$templateName.".".$charSet.".sql.txt";
	$file = fopen($dir."/files/".$filename, "wb");

    fputs ($file, 'SET CHARACTER SET '.$charSet.';'."\n");
    $fields = array();
    $fieldnames = array();
    $fieldsequalsvalues = array();
    $dbm = new DB;
    $dbm->query('SHOW COLUMNS FROM '.CPO_PAGETEMPLATES);
    while($dbm->next_record()) {
        if ($dbm->v('Field') == 'id')  continue;
        $fieldnames[] = $dbm->v('Field');
        $fields[] = "`".$dbm->v('Field')."`";
        $fieldstring = implode(", ", $fields);
    }
    $dbm = new DB;
    $dbm->query('SELECT '.$fieldstring.' FROM '.CPO_PAGETEMPLATES.' WHERE id='.addslashes($_REQUEST['pagetemplate']));
    while($dbm->next_record()) {
        $fieldsequalsvalues = array();
        foreach ($fieldnames AS $field)  {
            $value = str_replace("'","''",$dbm->v($field));
            $value = addcslashes($value,'\\');
            $value = str_replace("\r",'\r',$value);
            $value = str_replace("\n",'\n',$value);
            if ($field == 'user_id') $value = '###CPO_PAGETEMPLATES_USERID###';
            if ($field == 'saved') $value = '###CPO_PAGETEMPLATES_SAVED###';
            if ($field == 'name') $value .= ' [IMPORT]';
            $fieldsequalsvalues[] = ($charSet == 'utf8') ? "'".utf8_encode($value)."'" : "'".$value."'";
        }
        $fieldsequalsvaluesstring = implode(", ", $fieldsequalsvalues);
        $insertstring = "INSERT INTO ###CPO_PAGETEMPLATES### (".$fieldstring.") VALUES (".$fieldsequalsvaluesstring."); "."\n";
        fputs ($file, $insertstring);
    }
    fclose ($file);
	$message[] = sprintf(__('Page-template was saved as <em>%s</em>.'), '<a href="files/'.$filename.'" target="_blank">'.$activeModules['templates']['directory']."/files/".$filename.'</a>');
}

if (isset($_POST['go-import']) && $_FILES['importfile']['name']!='') {
    if ($_FILES['importfile']['size']) {

        // upload ok
        $path = CPO_BASEDIR.'_data/';
        $filename = tempnam($path, 'import');

        // move the uploaded file to the new place
        if (!@move_uploaded_file($_FILES['importfile']['tmp_name'], $filename)) {
            $message[] = sprintf(__('<b>ERROR:</b> Make sure the webserver has write-access to the directory %s.'),
                '<em>'.htmlspecialchars(dirname($filename)).'</em>');
            include(CPO_BASEDIR.'_include/message.php');
            return;
        }
        @chmod($filename, 0666);

        $sqllines = file($filename);

        $dbm = new DB;
        $template_id = 0;
        // Durchgehen des Arrays und Anzeigen des HTML-Quelltexts inkl. Zeilennummern
        foreach ($sqllines as $sqlline_num => $sqlline) {
            if (strpos($sqlline,'###CPO_TEMPLATES_CTIME###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_CTIME###',date('Y-m-d H:i:s'),$sqlline);
            if (strpos($sqlline,'###CPO_TEMPLATES_CHANGER###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_CHANGER###',addslashes($_SESSION['SID_login']).' [IMPORT]',$sqlline);
            if (strpos($sqlline,'###CPO_TEMPLATES###') !== false) {
                $sqlline = str_replace('###CPO_TEMPLATES###',$dbPrefix.'_templates',$sqlline);
                $dbm->query($sqlline);
                // anschlieend die Nummer des Templates ermiteln
                $query = 'SELECT last_insert_id()';
                $dbm->query($query); 
                $dbm->next_record();
                $template_id = $dbm->v('last_insert_id()');
                continue;
            }
            if (strpos($sqlline,'###CPO_PLACEHOLDERS###') !== false) $sqlline = str_replace('###CPO_PLACEHOLDERS###',$dbPrefix.'_placeholders',$sqlline);
            if (strpos($sqlline,'###CPO_PAGETEMPLATES###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES###',$dbPrefix.'_pagetemplates',$sqlline);
            if (strpos($sqlline,'###CPO_PAGETEMPLATES_USERID###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES_USERID###',addslashes($_SESSION['SID_user']['id']),$sqlline);
            if (strpos($sqlline,'###CPO_PAGETEMPLATES_SAVED###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES_SAVED###',date('Y-m-d H:i:s'),$sqlline);
            if (strpos($sqlline,'###CPO_TEMPLATES_ID###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_ID###',$template_id,$sqlline);
//            echo "Line #<b>{$sqlline_num}</b> : " . htmlspecialchars($sqlline) . "<br>\n";
            $dbm->query($sqlline);
        }
        @unlink($filename);
        $message[] = sprintf(__('The template file <em>%s</em> was uploaded and saved as a new template.'),$_FILES['importfile']['name']);
    } 
}

if (isset($_POST['go-import']) && $_FILES['importfile']['name']=='') {
    $message[] = ___('Please specify an import file.');
}


include(CPO_BASEDIR.'_include/message.php');
include(CPO_BASEDIR.$activeModules['templates']['directory'].'/producer.inc.php');

		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Export').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		// templates
        echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Template:');
            echo '</td>';
            echo '<td class="rightrow"><form action="templates.php" method="POST"><input type="hidden" name="action" value="export_template">';
			echo '<select name="template" size="1">';
			$db->query('SELECT id, name '
				.'FROM '.CPO_TEMPLATES.' ORDER BY name ASC');
			while ($db->next_record()) {
				echo '<option value="'.$db->v('id').'">'.$db->v('name').'</option>';
			}
			echo '</select> <input type="submit" value="'.__('export file').'"></form>';
            echo '</td>';
		echo '</tr>';

		if (version_compare($CPO['version'], '4.1.0') >= 0) {
			// page_templates
			$query = 'SELECT id, name FROM '.CPO_PAGETEMPLATES.' '
					.'ORDER BY name';
			$db->query($query);
			$_pagetemplates = array();
			while ($db->next_record()) {
				$_pagetemplates[$db->v('id')] = $db->v('name');
			}

			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Page-templates:');
				echo '</td>';
				echo '<td class="rightrow"><form action="templates.php" method="POST"><input type="hidden" name="action" value="export_page_template">';
				echo '<select name="pagetemplate" size="1">';
				foreach ($_pagetemplates as $k=>$v) {
					echo '<option value="'.htmlspecialchars($k).'">'.htmlspecialchars($v).'</option>';
				}
				echo '</select> <input type="submit" value="'.__('export file').'"></form>';
				echo '</td>';
			echo '</tr>';
		}        

		echo '</tbody></table>';

		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Import').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

        echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Filename:');
            echo '</td>';
            echo '<td class="rightrow"><form action="templates.php" method="POST" enctype="multipart/form-data">';
			echo '<input type="file" name="importfile" value="" size="40"/><br /><input type="submit" name="go-import" value="'.__('import file').'" /></form>';
            echo '</td>';
		echo '</tr>';


		echo '</tbody></table>';

require(CPO_BASEDIR.'_include/footer.php');
?>
